summaryrefslogtreecommitdiff
path: root/tests/chgrp
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2000-12-15 14:49:48 +0000
committerJim Meyering <jim@meyering.net>2000-12-15 14:49:48 +0000
commitd952853f74c8c60ac4f5f5c602fcf81886297d06 (patch)
treef4e9abfa837ea783c59585266e57cb9085c8afcb /tests/chgrp
parent3ebf224b28dc31489338c3ecba7fb01344ca8758 (diff)
downloadcoreutils-d952853f74c8c60ac4f5f5c602fcf81886297d06.tar.xz
*** empty log message ***
Diffstat (limited to 'tests/chgrp')
-rwxr-xr-xtests/chgrp/recurse56
1 files changed, 56 insertions, 0 deletions
diff --git a/tests/chgrp/recurse b/tests/chgrp/recurse
new file mode 100755
index 000000000..5e0c8995f
--- /dev/null
+++ b/tests/chgrp/recurse
@@ -0,0 +1,56 @@
+#!/bin/sh
+# make sure chgrp handles --recursive w/symlinks
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chgrp --version
+fi
+
+pwd=`pwd`
+tmp=slink.$$
+trap 'status=$?; cd $pwd; rm -rf $tmp && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo 'failure in testing framework' 1>&2
+ (exit 1); exit
+fi
+
+groups=`id -nG 2>/dev/null`
+case "$groups" in
+ *' '*) ;;
+ *) cat <<EOF 1>&2
+$0: this test requires that you be a member of more than one group,
+but running \`id -nG' either failed or found just one.
+EOF
+ (exit 77); exit
+ ;;
+esac
+
+set _ $groups; shift
+g1=$1
+g2=$2
+
+fail=0
+
+# chgrp -R should not traverse a symlink to a directory.
+mkdir d e
+touch e/f
+ln -s ../e d/s
+chgrp -R $g1 e/f || fail=1
+# Neither of the following should change the group of e/f
+chgrp -R $g2 d
+set _ `ls -l e/f`; g=$5; test "$g" = $g1 || fail=1
+chgrp --deref -R $g2 d
+set _ `ls -l e/f`; g=$5; test "$g" = $g1 || fail=1
+
+# Even when the symlink-to-directory is a command line argument, it should
+# not be traversed. So this shouldn't change the group of e/f either.
+chgrp --deref -R $g2 d/s || fail=1
+set _ `ls -l e/f`; g=$5; test "$g" = $g1 || fail=1
+
+(exit $fail); exit